VERSION 5.00
Begin VB.Form Form1 
   AutoRedraw      =   -1  'True
   BackColor       =   &H00800000&
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Rocket Test"
   ClientHeight    =   8880
   ClientLeft      =   2520
   ClientTop       =   2175
   ClientWidth     =   11940
   ControlBox      =   0   'False
   DrawWidth       =   32000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   8880
   ScaleWidth      =   11940
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Sub drawrocket(a As Integer)
Dim b%, c%, drawx(25), drawy(25)
rocket(a).adj = rocket(a).hyp * Cos(rocket(a).ang * (pi / 180))
rocket(a).opp = rocket(a).hyp * Sin(rocket(a).ang * (pi / 180))
Form1.DrawWidth = 2
Form1.Line (rocket(a).xloc + rocket(a).adj, rocket(a).yloc + rocket(a).opp)-(rocket(a).xloc - rocket(a).adj, rocket(a).yloc - rocket(a).opp), RGB(127, 127, 127)
For b = 1 To rocket(a).partcount
    Select Case rocket(a).part(b).type
        Case engine
            drawx(b) = rocket(a).part(b).r * Cos(rocket(a).part(b).ang * (pi / 180))
            drawy(b) = rocket(a).part(b).r * Sin(rocket(a).part(b).ang * (pi / 180))
            Form1.DrawWidth = 2
            Form1.PSet (rocket(a).xloc + drawx(b), rocket(a).yloc + drawy(b)), RGB(255, 0, 0)
            'Form1.PSet (rocket(a).xloc + rocket(a).part(b).xloc, rocket(a).yloc + rocket(a).part(b).yloc), RGB(255, 0, 0)
            If rocket(a).part(b).active = 1 And rocket(a).part(b).weight > 0 Then
                For c = 1 To explosioncount
                    If explosion(c).stage = -1 Then
                        explosion(c).stage = 0
                        explosion(c).count = 0
                        explosion(c).fullcount = rocket(a).part(b).rate * 5 * Rnd + 3
                        explosion(c).countstep = explosion(c).fullcount / 5
                        explosion(c).xloc = rocket(a).xloc + rocket(a).part(b).xloc
                        explosion(c).yloc = rocket(a).yloc + rocket(a).part(b).yloc
                        GoTo finished
                    End If
                Next
                explosioncount = explosioncount + 1
                explosion(explosioncount).stage = 0
                explosion(explosioncount).count = 0
                explosion(explosioncount).fullcount = rocket(a).part(b).rate * 5 * Rnd + 3
                explosion(explosioncount).countstep = explosion(explosioncount).fullcount / 5
                explosion(explosioncount).xloc = rocket(a).xloc + rocket(a).part(b).xloc
                explosion(explosioncount).yloc = rocket(a).yloc + rocket(a).part(b).yloc
finished:
        End If
        Case strut
        
        Case cargo
    End Select
Next

End Sub

Sub eraserocket(a As Integer)
Dim b%, c%, drawx(25), drawy(25)
rocket(a).adj = rocket(a).hyp * Cos(rocket(a).ang * (pi / 180))
rocket(a).opp = rocket(a).hyp * Sin(rocket(a).ang * (pi / 180))
Form1.DrawWidth = 2
Form1.Line (rocket(a).xloc + rocket(a).adj, rocket(a).yloc + rocket(a).opp)-(rocket(a).xloc - rocket(a).adj, rocket(a).yloc - rocket(a).opp), Form1.BackColor

For b = 1 To rocket(a).partcount
    Select Case rocket(a).part(b).type
        Case engine
            drawx(b) = rocket(a).part(b).r * Cos(rocket(a).part(b).ang * (pi / 180))
            drawy(b) = rocket(a).part(b).r * Sin(rocket(a).part(b).ang * (pi / 180))
            Form1.DrawWidth = 2
            Form1.PSet (rocket(a).xloc + drawx(b), rocket(a).yloc + drawy(b)), Form1.BackColor
            'Form1.PSet (rocket(a).xloc + rocket(a).part(b).xloc, rocket(a).yloc + rocket(a).part(b).yloc), Form1.BackColor
            
        Case strut
        
        Case cargo
    End Select
Next


End Sub


Private Sub Form_KeyPress(KeyAscii As Integer)
If KeyAscii = 27 Then
    End
End If
End Sub

Private Sub Form_Load()
Dim a%, b%, c%, i%

pi = 3.141593
Form1.Show
Randomize

rocketcount = 1
For a = 1 To rocketcount
    rocket(a).partcount = 2
    rocket(a).xloc = Form1.Width / 2
    rocket(a).yloc = Form1.Height - 1000
    rocket(a).ang = 90
    rocket(a).hyp = 100
    For b = 1 To 2
        rocket(a).part(b).type = engine
        rocket(a).part(b).time = 0
        rocket(a).part(b).fulltime = 0
        rocket(a).part(b).r = 100
        rocket(a).part(b).ang = 0
        rocket(a).part(b).weight = 250
        rocket(a).part(b).rate = 1.55
    Next
    rocket(a).part(1).ang = 120
    rocket(a).part(2).ang = 60
    rocket(a).part(1).xloc = rocket(a).part(1).r * Cos(rocket(a).part(1).ang * (pi / 180))
    rocket(a).part(1).yloc = rocket(a).part(1).r * Sin(rocket(a).part(1).ang * (pi / 180))
    rocket(a).part(2).xloc = rocket(a).part(2).r * Cos(rocket(a).part(2).ang * (pi / 180))
    rocket(a).part(2).yloc = rocket(a).part(2).r * Sin(rocket(a).part(2).ang * (pi / 180))

Next


Dim startTime As Long

Do
DoEvents

'2018, timing
startTime = GetTickCount

For a = 1 To rocketcount
    Call eraserocket(a)
    rocket(a).weight = 1000
    For b = 1 To rocket(a).partcount
        rocket(a).weight = rocket(a).weight + rocket(a).part(b).weight
    Next
    For b = 1 To rocket(a).partcount
        Select Case rocket(a).part(b).type
            Case engine
                
                'countdown
                If rocket(a).part(b).time > 0 Then
                    rocket(a).part(b).time = rocket(a).part(b).time - 1
                End If
                'on at zero
                If rocket(a).part(b).time = 0 Then
                    rocket(a).part(b).active = 1 'Not rocket(a).part(b).active
                    rocket(a).part(b).time = rocket(a).part(b).fulltime
                End If
                'go if active
                If rocket(a).part(b).active = 1 And rocket(a).part(b).weight > 0 Then
                    rocket(a).ang = rocket(a).ang - (rocket(a).part(b).xloc / 15.5 * rocket(a).part(b).rate)
                    rocket(a).part(b).ang = rocket(a).part(b).ang - (rocket(a).part(b).xloc / 15.5 * rocket(a).part(b).rate)
                    rocket(a).xdis = rocket(a).xdis + (rocket(a).part(b).rate * Cos(rocket(a).ang * (pi / 180)))
                    rocket(a).ydis = rocket(a).ydis + (rocket(a).part(b).rate * Sin(rocket(a).ang * (pi / 180)))
                    rocket(a).part(b).weight = rocket(a).part(b).weight - rocket(a).part(b).rate
                End If
                
            Case strut
            
            Case cargo
        End Select
    Next
    '''gravity'''
    rocket(a).ydis = rocket(a).ydis - 3
    'stop at bottom
    If rocket(a).yloc > Form1.Height Then
        rocket(a).yloc = Form1.Height
        rocket(a).ydis = 0
    End If
    
    '''move'''
    rocket(a).xloc = rocket(a).xloc - rocket(a).xdis
    rocket(a).yloc = rocket(a).yloc - rocket(a).ydis
    Call drawrocket(a)
    '''explosions'''
    For c = 1 To explosioncount
        If explosion(c).count < explosion(c).fullcount Then
            explosion(c).count = explosion(c).count + explosion(c).countstep
        End If
        If explosion(c).count >= explosion(c).fullcount And explosion(c).stage = 0 Then
            explosion(c).count = 0
            explosion(c).stage = 1
        End If
        If explosion(c).count >= explosion(c).fullcount And explosion(c).stage = 1 Then
            explosion(c).count = 0
            explosion(c).stage = -1
            GoTo done
        End If
        If explosion(c).stage = 0 Then
            Form1.DrawWidth = explosion(c).count + 1
            PSet (explosion(c).xloc, explosion(c).yloc), RGB(255, 255, 0)
        End If
        If explosion(c).stage = 1 Then
            Form1.DrawWidth = explosion(c).count + 1
            PSet (explosion(c).xloc, explosion(c).yloc), Form1.BackColor
        End If
done:
    Next
        
Next

'2018, timing
While startTime + 16 > GetTickCount
Wend


Loop

End Sub


